=== debian/changelog ===
cmake (3.7.2-1) unstable; urgency=medium

  * New upstream release.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 15 Jan 2017 16:00:24 +0100

cmake (3.7.1-1) unstable; urgency=medium

  * New upstream release.
  * Don't try to link against libuv on hurd. (Closes: #844374)

 -- Felix Geyer <fgeyer@debian.org>  Sun, 04 Dec 2016 01:01:26 +0100

cmake (3.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove libjapser from the autopkgtest, the package has been removed
    from the archive.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 13 Nov 2016 19:35:16 +0100

cmake (3.7.0~rc3-1) experimental; urgency=medium

  * New upstream release.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 06 Nov 2016 11:59:35 +0100

cmake (3.7.0~rc2-1) experimental; urgency=medium

  * New upstream release.
  * Drop CMakeParseImplicitLinkInfo_Exclude_libclang_rt.patch, fixed upstream.
  * Refresh patches.
  * Add libuv1-dev to Build-Depends, required by new release.
  * Update Uploaders. (Closes: #840858)

 -- Felix Geyer <fgeyer@debian.org>  Sun, 30 Oct 2016 23:21:54 +0100
